diff --git a/doc/NEWS b/doc/NEWS
index 8e4f293f7f..06f7e69ec2 100644
--- a/doc/NEWS
+++ b/doc/NEWS
@@ -60,6 +60,10 @@ Major changes from 1.9.0-jumbo-1 (May 2019) in this bleeding-edge version:
   --format=#ipmi-opencl  will pick the RAKP-opencl format.  We already had
   the '@' symbol for searching in alorithm name.  [magnum; 2019]
 
+- Worked out a new KISS solution "FMT_BLOB" for non-hash formats, so they can
+  still benefit from same-salt optimizations/exploits.  [magnum; 2019]
+
+
 Major changes from 1.8.0-jumbo-1 (December 2014) to 1.9.0-jumbo-1 (May 2019):
 
 - Updated to 1.9.0 core, which brought the following relevant major changes:
diff --git a/src/bench.c b/src/bench.c
index ed9ed2282e..d7d0e45213 100644
--- a/src/bench.c
+++ b/src/bench.c
@@ -431,7 +431,13 @@ char *benchmark_format(struct fmt_main *format, int salts,
 	if (format->params.binary_size > binary_size) {
 		binary_size = format->params.binary_size;
 		binary = mem_alloc_tiny(binary_size, MEM_ALIGN_SIMD);
-		memset(binary, 0x55, binary_size);
+		if (format->params.flags & FMT_BLOB) {
+			/* For this case we'd ideally use two_binaries[2] */
+			memcpy(binary,
+			       format->methods.binary(format->params.tests[0].ciphertext),
+			       binary_size);
+		} else
+			memset(binary, 0x55, binary_size);
 	}
 
 	for (index = 0; index < 2; index++) {
diff --git a/src/cracker.c b/src/cracker.c
index 8ccc5b26d6..549708deff 100644
--- a/src/cracker.c
+++ b/src/cracker.c
@@ -278,6 +278,16 @@ static void crk_remove_salt(struct db_salt *salt)
 	dyna_salt_remove(salt->salt);
 }
 
+#define BLOB_BINARY(b) ((crk_params->flags & FMT_BLOB) ?	\
+                        (((fmt_data*)(b))->blob) : (b))
+
+#define BLOB_SIZE(b) ((crk_params->flags & FMT_BLOB) ?	  \
+                      (((fmt_data*)(b))->size) : (crk_params->binary_size))
+
+#define BLOB_FREE(b) do { if ((crk_params->flags & FMT_BLOB) && (b) &&  \
+                              (((fmt_data*)(b))->flags & FMT_DATA_ALLOC)) \
+			MEM_FREE(((fmt_data*)(b))->blob); } while (0)
+
 /*
  * Updates the database after a password has been cracked.
  */
@@ -303,6 +313,7 @@ static void crk_remove_hash(struct db_salt *salt, struct db_password *pw)
 		while (*current != pw)
 			current = &(*current)->next;
 		*current = pw->next;
+		BLOB_FREE(pw->binary);
 		pw->binary = NULL;
 		return;
 	}
@@ -347,8 +358,10 @@ static void crk_remove_hash(struct db_salt *salt, struct db_password *pw)
  * Or, if FMT_REMOVE, the format explicitly intends to traverse the list
  * during cracking, and will remove entries at that point.
  */
-	if (crk_guesses || (crk_params->flags & FMT_REMOVE))
+	if (crk_guesses || (crk_params->flags & FMT_REMOVE)) {
+		BLOB_FREE(pw->binary);
 		pw->binary = NULL;
+	}
 }
 
 /* Negative index is not counted/reported (got it from pot sync) */
@@ -410,7 +423,7 @@ static int crk_process_guess(struct db_salt *salt, struct db_password *pw,
 	}
 
 	// Ok, FIX the salt  ONLY if -regen-lost-salts=X was used.
-	if (options.regen_lost_salts && (crk_db->format->params.flags & FMT_DYNAMIC) == FMT_DYNAMIC)
+	if (options.regen_lost_salts && (crk_params->flags & FMT_DYNAMIC) == FMT_DYNAMIC)
 		crk_guess_fixup_salt(pw->source, *(char**)(salt->salt));
 
 	/* If we got this crack from a pot sync, don't report or count */
@@ -430,7 +443,7 @@ static int crk_process_guess(struct db_salt *salt, struct db_password *pw,
 			john_max_cands = status.cands - options.max_cands +
 				crk_params->max_keys_per_crypt;
 
-		if (dupe)
+		if (dupe && !(crk_params->flags & FMT_BLOB))
 			ct = NULL;
 		else
 			ct = ldr_pot_source(
@@ -492,7 +505,6 @@ static int crk_remove_pot_entry(char *ciphertext)
 	struct db_password *pw;
 	char argcopy[LINE_BUFFER_SIZE];
 	void *pot_salt;
-	char *binary = crk_methods.binary(ciphertext);
 
 	/*
 	 * If the pot entry is truncated from a huge ciphertext, we have
@@ -567,8 +579,10 @@ static int crk_remove_pot_entry(char *ciphertext)
 	}
 	else {
 		int hash;
+		char *binary = crk_methods.binary(ciphertext);
 
 		hash = crk_methods.binary_hash[salt->hash_size](binary);
+		BLOB_FREE(binary);
 		if (!(salt->bitmap[hash / (sizeof(*salt->bitmap) * 8)] &
 		      (1U << (hash % (sizeof(*salt->bitmap) * 8)))))
 			return 0;
diff --git a/src/formats.c b/src/formats.c
index 480b009ee2..d238f00c4f 100644
--- a/src/formats.c
+++ b/src/formats.c
@@ -327,6 +327,33 @@ static char* is_key_right(struct fmt_main *format, int index,
 }
 #endif
 
+#define BLOB_BINARY(b) ((format->params.flags & FMT_BLOB) ?	\
+                        (((fmt_data*)(b))->blob) : (b))
+
+#define BLOB_SIZE(b) ((format->params.flags & FMT_BLOB) ?	  \
+                      (((fmt_data*)(b))->size) : (format->params.binary_size))
+
+#define BLOB_FREE(b) do { if ((format->params.flags & FMT_BLOB) && (b) && \
+                              (((fmt_data*)(b))->flags & FMT_DATA_ALLOC)) \
+			MEM_FREE(((fmt_data*)(b))->blob); } while (0)
+
+int fmt_bincmp(void *b1, void *b2, struct fmt_main *format)
+{
+	if (!(format->params.flags & FMT_BLOB))
+		return memcmp(b1, b2, format->params.binary_size);
+
+	size_t s1 = ((fmt_data*)b1)->size;
+	size_t s2 = ((fmt_data*)b2)->size;
+
+	if (s1 != s2)
+		return 1;
+
+	b1 = ((fmt_data*)b1)->blob;
+	b2 = ((fmt_data*)b2)->blob;
+
+	return memcmp(b1, b2, s1);
+}
+
 static char *fmt_self_test_body(struct fmt_main *format,
     void *binary_copy, void *salt_copy, struct db_main *db, int full_lvl)
 {
@@ -647,10 +674,12 @@ static char *fmt_self_test_body(struct fmt_main *format,
 
 		/* validate that binary() returns cleaned buffer */
 		if (extra_tests && !binary_cleaned_warned && format->params.binary_size) {
+			BLOB_FREE(binary);
 			memset(binary, 0xAF, format->params.binary_size);
 			binary = format->methods.binary(ciphertext);
 			if (((unsigned char*)binary)[format->params.binary_size-1] == 0xAF)
 			{
+				BLOB_FREE(binary);
 				memset(binary, 0xCC, format->params.binary_size);
 				binary = format->methods.binary(ciphertext);
 				if (((unsigned char*)binary)[format->params.binary_size-1] == 0xCC)
@@ -661,6 +690,7 @@ static char *fmt_self_test_body(struct fmt_main *format,
 				}
 			}
 			/* Clean up the mess we might have caused */
+			BLOB_FREE(binary);
 			memset(binary, 0, format->params.binary_size);
 			binary = format->methods.binary(ciphertext);
 		}
@@ -1195,9 +1225,9 @@ static void test_fmt_split_unifies_case(struct fmt_main *format, char *ciphertex
 		ret = format->methods.split(ret, 0, format);
 		ret_copy = strdup(ret);
 		bin = format->methods.binary(ret_copy);
-		if (format->params.binary_size>4) {
-			bin_hex = mem_alloc(format->params.binary_size*2+1);
-			base64_convert(bin, e_b64_raw, format->params.binary_size, bin_hex, e_b64_hex, format->params.binary_size*2+1, 0, 0);
+		if (BLOB_SIZE(bin) > 4) {
+			bin_hex = mem_alloc(BLOB_SIZE(bin) * 2 + 1);
+			base64_convert(BLOB_BINARY(bin), e_b64_raw, BLOB_SIZE(bin), bin_hex, e_b64_hex, BLOB_SIZE(bin) * 2 + 1, 0, 0);
 			cp = strstr(ret_copy, bin_hex);
 			strupr(bin_hex);
 			if (cp) {
@@ -1219,6 +1249,7 @@ static void test_fmt_split_unifies_case(struct fmt_main *format, char *ciphertex
 			}
 			MEM_FREE(bin_hex);
 		}
+		BLOB_FREE(bin);
 		if (format->params.salt_size>4 && format->params.salt_size < strlen(ret_copy)-10) {
 			bin_hex = mem_alloc(format->params.salt_size*2+1);
 			bin = format->methods.salt(ret_copy);
@@ -1357,18 +1388,18 @@ static void test_fmt_split_unifies_case_3(struct fmt_main *format,
 	orig_salt = NULL;
 
 	binary = format->methods.binary(split_ret);
-	if (binary != NULL) {
-
-		orig_binary = mem_alloc(format->params.binary_size);
-		memcpy(orig_binary, binary, format->params.binary_size);
+	if (binary) {
+		orig_binary = mem_alloc(BLOB_SIZE(binary));
+		memcpy(orig_binary, BLOB_BINARY(binary), BLOB_SIZE(binary));
 
 		salt = format->methods.salt(split_ret);
 		dyna_salt_create(salt);
-		if (salt != NULL && format->params.salt_size) {
+		if (salt && format->params.salt_size) {
 			orig_salt = mem_alloc(format->params.salt_size);
 			memcpy(orig_salt, salt, format->params.salt_size);
 		}
 		dyna_salt_remove(salt);
+		BLOB_FREE(binary);
 	}
 
 /*
@@ -1400,11 +1431,11 @@ static void test_fmt_split_unifies_case_3(struct fmt_main *format,
 				*is_need_unify_case = 0;
 			binary = format->methods.binary(split_ret);
 
-			if (binary != NULL)
-			if (memcmp(orig_binary, binary, format->params.binary_size) != 0) {
+			if (binary && fmt_bincmp(orig_binary, binary, format)) {
 				// Do not need to unify cases in split() and add
 				// FMT_SPLIT_UNIFIES_CASE
 				*is_need_unify_case = 0;
+				BLOB_FREE(binary);
 			}
 		} else
 			*is_need_unify_case = 0;
@@ -1422,11 +1453,11 @@ static void test_fmt_split_unifies_case_3(struct fmt_main *format,
 				*is_need_unify_case = 0;
 			binary = format->methods.binary(split_ret);
 
-			if (binary != NULL)
-			if (memcmp(orig_binary, binary, format->params.binary_size) != 0) {
+			if (binary && fmt_bincmp(orig_binary, binary, format)) {
 				// Do not need to unify cases in split() and add
 				// FMT_SPLIT_UNIFIES_CASE
 				*is_need_unify_case = 0;
+				BLOB_FREE(binary);
 			}
 		} else
 			*is_need_unify_case = 0;
@@ -1580,6 +1611,7 @@ char *fmt_self_test(struct fmt_main *format, struct db_main *db)
 
 	binary_copy = alloc_binary(&binary_alloc,
 	    format->params.binary_size?format->params.binary_size:1, format->params.binary_align);
+	memset(binary_copy, 0, format->params.binary_size);
 	salt_copy = alloc_binary(&salt_alloc,
 	    format->params.salt_size?format->params.salt_size:1, format->params.salt_align);
 
@@ -1590,6 +1622,7 @@ char *fmt_self_test(struct fmt_main *format, struct db_main *db)
 	self_test_running = 0;
 
 	MEM_FREE(salt_alloc);
+	BLOB_FREE(binary_copy);
 	MEM_FREE(binary_alloc);
 
 	return retval;
diff --git a/src/formats.h b/src/formats.h
index 0ba3143112..4ee1da1d14 100644
--- a/src/formats.h
+++ b/src/formats.h
@@ -118,6 +118,8 @@ struct db_salt;
 #define FMT_OMP				0
 #define FMT_OMP_BAD			0
 #endif
+/* Non-hash format. If used, binary_size must be 0 */
+#define FMT_BLOB			0x04000000
 /* We've already warned the user about hashes of this type being present */
 #define FMT_WARNED			0x80000000
 
@@ -132,6 +134,28 @@ struct fmt_tests {
 	char *fields[10];
 };
 
+/*
+ * Flags for fmt_data.
+ */
+/* Blob portion is tiny-alloc. */
+#define FMT_DATA_TINY			0x00000001
+/* Blob portion is malloc, so needs to be freed when done with it. */
+#define FMT_DATA_ALLOC			0x00000002
+
+/*
+ * Variable size data for non-hashes (formerly stored in "salt").
+ * "size" is the size of blob only. Size of data returned is always
+ * just sizeof(fmt_data). The blob is either mem_alloc_tiny and flag
+ * is FMT_DATA_TINY, or alloced and flag is FMT_DATA_ALLOC.
+ * The latter needs free when we're done with it. Regardless, the
+ * loader never copies it. The cracker uses the pointer (and may free it).
+ */
+typedef struct {
+	unsigned int flags;
+	size_t size;
+	void *blob;
+} fmt_data;
+
 /*
  * Parameters of a hash function and its cracking algorithm.
  */
@@ -246,6 +270,7 @@ struct fmt_methods {
 	char *(*split)(char *ciphertext, int index, struct fmt_main *self);
 
 /* Converts an ASCII ciphertext to binary, possibly using the salt */
+/* Or, converts an ASCII non-hash data blob to a fmt_data struct */
 	void *(*binary)(char *ciphertext);
 
 /* Converts an ASCII salt to its internal representation */
@@ -408,6 +433,13 @@ extern void fmt_all_done(void);
  */
 extern char *fmt_self_test(struct fmt_main *format, struct db_main *db);
 
+/*
+ * Compare the real binary, whatever it is:
+ * If this is not FMT_BLOB we do a plain memcmp. If it is, we
+ * memcmp the pointed-to binaries, with correct sizes.
+ */
+extern int fmt_bincmp(void *b1, void *b2, struct fmt_main *format);
+
 /*
  * Default methods.
  */
diff --git a/src/loader.c b/src/loader.c
index f9aee50adf..8f682c15d8 100644
--- a/src/loader.c
+++ b/src/loader.c
@@ -890,6 +890,16 @@ static struct list_main *ldr_init_words(char *login, char *gecos, char *home)
 	return words;
 }
 
+#define BLOB_BINARY(b) ((format->params.flags & FMT_BLOB) ?	\
+                        (((fmt_data*)(b))->blob) : (b))
+
+#define BLOB_SIZE(b) ((format->params.flags & FMT_BLOB) ?	  \
+                      (((fmt_data*)(b))->size) : (format->params.binary_size))
+
+#define BLOB_FREE(b) do { if ((format->params.flags & FMT_BLOB) && (b) && \
+                              (((fmt_data*)(b))->flags & FMT_DATA_ALLOC)) \
+			MEM_FREE(((fmt_data*)(b))->blob); } while (0)
+
 #ifdef HAVE_FUZZ
 void ldr_load_pw_line(struct db_main *db, char *line)
 #else
@@ -949,16 +959,17 @@ static void ldr_load_pw_line(struct db_main *db, char *line)
 		if (options.flags & FLG_REJECT_PRINTABLE) {
 			int i = 0;
 
-			while (isprint((int)((unsigned char*)binary)[i]) &&
-			       i < format->params.binary_size)
+			while (isprint((int)((unsigned char*)BLOB_BINARY(binary))[i]) &&
+			       i < BLOB_SIZE(binary))
 				i++;
 
-			if (i == format->params.binary_size) {
+			if (i == BLOB_SIZE(binary)) {
 				if (john_main_process)
 				fprintf(stderr, "rejecting printable binary"
 				        " \"%.*s\" (%s)\n",
-				        format->params.binary_size,
-				        (char*)binary, piece);
+				        (int)BLOB_SIZE(binary),
+				        (char*)BLOB_BINARY(binary), piece);
+				BLOB_FREE(binary);
 				continue;
 			}
 		}
@@ -967,8 +978,7 @@ static void ldr_load_pw_line(struct db_main *db, char *line)
 			int collisions = 0;
 			if ((current_pw = db->password_hash[pw_hash]))
 			do {
-				if (!memcmp(binary, current_pw->binary,
-				    format->params.binary_size) &&
+				if (!fmt_bincmp(binary, current_pw->binary, format) &&
 				    !strcmp(piece, format->methods.source(
 				    current_pw->source, current_pw->binary))) {
 					db->options->flags |= DB_NODUP;
@@ -997,7 +1007,10 @@ static void ldr_load_pw_line(struct db_main *db, char *line)
 				break;
 			} while ((current_pw = current_pw->next_hash));
 
-			if (current_pw) continue;
+			if (current_pw) {
+				BLOB_FREE(binary);
+				continue;
+			}
 		}
 
 		salt = format->methods.salt(piece);
@@ -1181,7 +1194,8 @@ static void ldr_load_pot_line(struct db_main *db, char *line)
 	struct db_password *current;
 
 	ciphertext = ldr_get_field(&line, db->options->field_sep_char);
-	if (ldr_trunc_valid(ciphertext, format) != 1) return;
+	if (ldr_trunc_valid(ciphertext, format) != 1)
+		return;
 	ciphertext = format->methods.split(ciphertext, 0, format);
 	binary = format->methods.binary(ciphertext);
 	hash = db->password_hash_func(binary);
@@ -1199,17 +1213,19 @@ static void ldr_load_pot_line(struct db_main *db, char *line)
 		 * can't treat with memcmp().
 		 */
 		if (hash || !ldr_isa_pot_source(ciphertext))
-		if (memcmp(binary, current->binary, format->params.binary_size))
+		if (fmt_bincmp(binary, current->binary, format))
 			continue;
 		if (ldr_pot_source_cmp(ciphertext,
 		    format->methods.source(current->source, current->binary)))
 			continue;
+		BLOB_FREE(current->binary);
 		current->binary = NULL; /* mark for removal */
 		need_removal = 1;
 	} while ((current = current->next_hash));
 
 	if (need_removal)
 		db->options->flags |= DB_NEED_REMOVAL;
+	BLOB_FREE(binary);
 }
 
 struct db_main *ldr_init_test_db(struct fmt_main *format, struct db_main *real)
diff --git a/src/loader.h b/src/loader.h
index 8ea5c5aa0a..30cbf8f250 100644
--- a/src/loader.h
+++ b/src/loader.h
@@ -26,7 +26,9 @@ struct db_password {
 /* Pointer to next password hash with the same salt */
 	struct db_password *next;
 
-/* Hot portion of or full binary ciphertext for fast comparison (aligned) */
+/* Hot portion of or full binary ciphertext for fast comparison (aligned).
+ * Alternatively, for non-hash formats: Non-salt data (that we used to
+ * incorrectly store in a "salt"). */
 	void *binary;
 
 /* After loading is completed: pointer to next password hash with the same salt
diff --git a/src/opencl_common.c b/src/opencl_common.c
index 859040eec1..883c0bce8e 100644
--- a/src/opencl_common.c
+++ b/src/opencl_common.c
@@ -1566,6 +1566,10 @@ static void* fill_opencl_device(size_t gws, void **binary)
 	return salt;
 }
 
+#define BLOB_FREE(b) do { if ((self->params.flags & FMT_BLOB) && (b) && \
+                              (((fmt_data*)(b))->flags & FMT_DATA_ALLOC)) \
+			MEM_FREE(((fmt_data*)(b))->blob); } while (0)
+
 // Do a test run with a specific global work size, return total duration
 // (or return zero for error or limits exceeded)
 static cl_ulong gws_test(size_t gws, unsigned int rounds, int sequential_id)
@@ -1609,6 +1613,7 @@ static cl_ulong gws_test(size_t gws, unsigned int rounds, int sequential_id)
 		return 0;
 	}
 	self->methods.cmp_all(binary, result);
+	BLOB_FREE(binary);
 
 	for (i = 0; (*multi_profilingEvent[i]); i++)
 		number_of_events++;
@@ -1871,6 +1876,7 @@ void opencl_find_best_lws(size_t group_size_limit, int sequential_id,
 
 			clear_profiling_events();
 		}
+		BLOB_FREE(binary);
 
 		/* Erase the 'spinning wheel' cursor */
 		if (john_main_process && isatty(fileno(stderr)))
